## bakefile-0.2.13.tar.gz

=== build/SConstruct ===

LIBXML2_VERSION = "2.6.32"
LIBXML2_URL = "ftp://xmlsoft.org/libxml2/libxml2-%s.tar.gz" % LIBXML2_VERSION
LIBXML2_PATCHES = ["libxml2-setup.py-fixes.patch"]
LIBXML2_CONFIGURE = "--disable-static --enable-python --disable-ftp --disable-http --disable-dependency-tracking"
LIBXML2_WINCONFIGURE = "ftp=no http=no html=no iconv=no python=yes"

PYTHON_VERSION = "2.5.2"
PYTHON_URL = "http://www.python.org/ftp/python/%(ver)s/python-%(ver)s.msi" % {"ver":PYTHON_VERSION}
PYTHON_FILES = ["python-makezip.py"]

PYWIN32_VERSION = "210"
PYWIN32_URL = "http://downloads.sourceforge.net/pywin32/pywin32-%s.zip" % PYWIN32_VERSION
PYWIN32_PATCHES = ["pywin32-no-win32inet.patch"]

LESSMSI_VERSION = "20051110"
LESSMSI_URL = "http://blogs.pingpoet.com/overflow/pubfiles/lessmsierables-%s.zip" % LESSMSI_VERSION
LESSMSI_PATCHES = ["lessmsi-no-gui.patch"]

INNOSETUP_VERSION = '5.2.3'
INNOSETUP_URL = 'http://files.jrsoftware.org/ispack/ispack-%s.exe' % INNOSETUP_VERSION
INNOUNP_URL = 'http://downloads.sourceforge.net/innounp/innounp020.rar'


from rlsbot import BuildEnvironment
env = BuildEnvironment()

# -----------------------------------------------------------------
# Python
# -----------------------------------------------------------------

src_lessmsi = env.ComponentSources(
        name="lessmsi",
        source=LESSMSI_URL,
        patches=LESSMSI_PATCHES,
        post_commands=["rm -f lessmsi.{exe,pdb}"])

lessmsi = env.BuildComponent(
        name="lessmsi",
        agent="mono",
        sources=src_lessmsi,
        deps=None,
        commands=[
            "mcs /target:exe /out:lessmsi.exe /r:wix /r:System.Windows.Forms /r:System.Drawing Source/*.cs",
        ],
        outputs=["*.exe", "*.dll"])



src_python = env.ComponentSources(
        name="python",
        source=PYTHON_URL,
        morefiles=PYTHON_FILES)

python_devel_win32 = env.BuildComponent(
        name="python-devel-win32",
        agent="win32",
        sources=src_python,
        deps=[lessmsi],
        commands=[
            "lessmsi /x python-%s.msi python" % PYTHON_VERSION,
        ],
        outputs=["python/SourceDir/*", "*.py"])



src_pywin32 = env.ComponentSources(
        name="pywin32",
        source=PYWIN32_URL,
        patches=PYWIN32_PATCHES)

pywin32 = env.BuildComponent(
        name="pywin32",
        agent="vs2003",
        sources=src_pywin32,
        deps=[(python_devel_win32, "py")],
        toolchain=env.VisualStudioToolchain,
        commands=[
            "py\\python setup.py build",
        ],
        outputs=["build/lib.win32-*/*"])



# -----------------------------------------------------------------
# libxml2 Python module
# -----------------------------------------------------------------

src_libxml2 = env.ComponentSources(
        name="libxml2",
        source=LIBXML2_URL,
        patches=LIBXML2_PATCHES,
        morefiles=["mac-python2.3.tar.gz"],
        post_commands=[
            "mv mac-python2.3 libxml2-*",
            "mv libxml2-*/* .",
            "rmdir libxml2-*",
        ])

libxml2_win32 = env.BuildComponent(
        name="libxml2-win32",
        agent="vs2003",
        sources=src_libxml2,
        deps=[(python_devel_win32, "py")],
        toolchain=env.VisualStudioToolchain,
        commands=[
            "cd win32",
            "cscript configure.js prefix=..\\dist %s sodir=..\\dist\\lib\\libxmlmods" % LIBXML2_WINCONFIGURE,
            "nmake -f makefile.msvc",
            "nmake -f makefile.msvc install",
            "cd ..\\python",
            "..\\py\\python setup.py build",
        ],
        outputs=["python/build/lib.win32-*/*", "dist/lib/libxmlmods"])



OSX_10_6_FLAGS="-O2 -arch i386 -arch x86_64 -isysroot /Developer/SDKs/MacOSX10.6.sdk"
OSX_10_5_FLAGS="-O2 -arch i386 -arch ppc -isysroot /Developer/SDKs/MacOSX10.5.sdk"
OSX_10_4_FLAGS="-O2 -arch i386 -arch ppc -isysroot /Developer/SDKs/MacOSX10.4u.sdk"

libxml2_osx = env.BuildComponent(
        name="libxml2-osx",
        agent="osx10.6",
        sources=src_libxml2,
        deps=None,
        commands=[
            # Build 10.5 version first, then install 10.4 version on top of
            # it.  This way, libxml2.dylib will be usable on all systems (and
            # py modules are installed in different places)
            "mkdir B10.5",
            "cd B10.5",
            "../configure --libdir=/usr/local/lib/bakefile/binmodules %s CFLAGS='%s' LDFLAGS='%s' --with-python=/usr/bin/python2.5" % (LIBXML2_CONFIGURE, OSX_10_5_FLAGS, OSX_10_5_FLAGS),
            "make install-strip DESTDIR=`pwd`/../DESTDIR",
            "cd ..",

            "mkdir B10.4",
            "cd B10.4",
            "../configure --libdir=/usr/local/lib/bakefile/binmodules %s CFLAGS='%s' LDFLAGS='%s' --with-python=`pwd`/../mac-python2.3" % (LIBXML2_CONFIGURE, OSX_10_4_FLAGS, OSX_10_4_FLAGS),
            "make install-strip DESTDIR=`pwd`/../DESTDIR",
            "cd ..",

            "cd DESTDIR/usr/local/lib/bakefile/binmodules",
            "mv ../../../../../Library/Python/2.5/site-packages 2.5",
            "mv python2.3/site-packages 2.3",
            "rm -rf python* pkgconfig *.la */*.la libxml2.dylib *.sh",
        ],
        environment={"MACOSX_DEPLOYMENT_TARGET":"10.4"},
        outputs=["DESTDIR/usr/local/lib/bakefile/binmodules/*"])



# -----------------------------------------------------------------
# Python distributable runtime
# -----------------------------------------------------------------

python_runtime_win32 = env.BuildComponent(
        name="python-runtime-win32",
        agent="win32",
        sources=[],
        deps=[python_devel_win32,
              (pywin32, "pywin32"),
              (libxml2_win32, "dist/lib")],
        commands=[
            #"mkdir dist",
            #"mkdir dist\\lib",
            "copy *.dll dist",
            "copy LICENSE.txt dist\\Python-LICENSE.txt",
            "copy DLLS\\_bsddb.pyd dist\\lib",
            "python python-makezip.py",
            "copy *.zip dist",
            "copy pywin32\\pywin32_system32\\pywintypes* dist\\lib",
            "copy pywin32\\win32\\win32file.pyd dist\\lib",
            "copy pywin32\\win32\\_win32sysloader.pyd dist\\lib",
            "copy pywin32\\win32\\lib\\win32con.py dist\\lib",
            "copy pywin32\\win32\\lib\\pywintypes.py dist\\lib",
        ],
        outputs=["dist/*"])


# -----------------------------------------------------------------
# innosetup
# -----------------------------------------------------------------

src_innounp = env.ComponentSources(
        name='innounp',
        source=INNOUNP_URL)

src_innosetup = env.ComponentSources(
        name='innosetup',
        source=INNOSETUP_URL)

innosetup = env.BuildComponent(
        name='innosetup',
        agent='win32',
        sources=src_innosetup,
        deps=[src_innounp],
        commands=[
            'innounp -x ispack-%s.exe' % INNOSETUP_VERSION,
            'move {app}\\ISCC?2.exe {app}\\ISCC.exe',
            'del {app}\\ISCC?1.exe',
            'move {app}\\ISCmplr?2.dll {app}\\ISCmplr.dll',
            'move {app}\\ISCmplr?1.dll {app}\\ISCmplr.dls',
        ],
        outputs=['{app}/*'])


# -----------------------------------------------------------------
# bakefile
# -----------------------------------------------------------------

src_bakefile = env.ComponentSources(
        name="bakefile",
        source="..",
        post_commands=["./bootstrap"])

bakefile_tarball = env.BuildComponent(
        name="bakefile-tarball",
        agent="unix",
        sources=src_bakefile,
        deps=None,
        commands=[
            "./configure --enable-maintainer-mode",
            "make doc",
            "make dist",
        ],
        outputs=["bakefile-*.tar.gz"])

src_bakefile_official = env.ComponentSources(
        name="bakefile-official",
        source=bakefile_tarball)


bakefile_osx = env.BuildComponent(
        name="bakefile-osx",
        agent="osx",
        sources=src_bakefile_official,
        deps=[(libxml2_osx, "pyextras")],
        commands=[
            "cd macosx",
            "EXTRA_BINMODULES=`pwd`/../pyextras ./makepkg.sh",
            ],
        outputs=["macosx/bakefile-*.dmg"])


bakefile_win32 = env.BuildComponent(
        name="bakefile-win32",
        agent="vs2003",
        sources=src_bakefile_official,
        deps=[(python_devel_win32, "py-dev"),
              (python_runtime_win32, "py-runtime"),
              (innosetup, 'inno')],
        toolchain=env.VisualStudioToolchain,
        commands=[
            "nmake -f makefile.vc PYTHONDIR=py-dev",
            "inno\\iscc bakefile.iss",
            ],
        outputs=["bakefile-*-setup.exe"])

=== debian/changelog ===
bakefile (0.2.9) unstable; urgency=low

  * added -I flag to bakefile_gen too
  * msevc4prj: fixed breakage of <debug-info> introduced in 0.2.7
  * added suncc backend
  * msvs2005prj, msvs2008prj: added support for x64 builds
  * msvs2008prj: fixed compatibility with VS 2010

 -- Vadim Zeitlin <vadim@wxwindows.org>  Feb, 03 Thu 2011 15:30:37 +0100

bakefile (0.2.8) unstable; urgency=low
  * msvc: fixed incorrect compiler flags for debug info without debug runtime

 -- Vadim Zeitlin <vadim@wxwindows.org>  Nov, 05 Thu 2009 19:46:10 +0100

bakefile (0.2.7) unstable; urgency=low

  * added getTagAttrib() helper (#97)
  * fixed shared library names and sonames on Solaris to use only one version
    number: use libfoo.so.1 for the file and the soname and libfoo.so for the
    only symlink
  * msvs2008prj: fixed MIDL compiler settings
  * autoconf, gnu: fixed pkgconfig module to respect DESTDIR (#248)
  * msvs*prj, msvc, msvc6prj: using debug info without debug runtime was fixed
    to keep all optimizations enabled (#212)

 -- Vadim Zeitlin <vadim@wxwindows.org>  Oct, 22 Thu 2009 14:49:57 +0200

bakefile (0.2.6) unstable; urgency=low

  * autoconf: fixed dependencies support for traditional Unix compilers
  * autoconf: correct shared library extension under HP-UX ia64
  * autoconf: added support for new (10 and 11) Intel C/C++ compiler versions
  * watcom: fixes for OpenWatcom 1.8 (Jiri Malak, #238)
  * fixed assert failure with wxWidgets' presets (#230)
  * msvs*prj: pass preprocessor flags to IDL compiler (#240)
  * msvs*prj: define WIN32 preprocessor symbol
  * fixed 100% CPU usage in bakefile_gen
  * added <debug-info-edit-and-continue> tag to support Visual Studio
    debugger's Edit and Continue feature
  * msvs*prj: allow overriding names of .vcproj files using MSVS_PROJECT_FILE
    variable (#224)

 -- Scott Bailey <Bailey@InsaneGenius.org>  Fri, 27 Mar 2009 09:33:32 -0700

bakefile (0.2.5) unstable; urgency=low

  * msvs2003prj, msvs2005prj: fixed PCH handling broken in 0.2.4.
  * mingw: fixed C compiler invocation broken in 0.2.4 (#231).

 -- Vadim Zeitlin <vadim@wxwindows.org>  Oct, 22 Wed 2008 17:17:22 +0200

bakefile (0.2.4) unstable; urgency=low

  * added support for Visual Studio 2008 (#186).
  * msvs200xprj: if "-o foo.vcproj" is specified on the command line, only
    generate foo.vcproj and not foo.sln (#174).
  * autoconf: fixes for non-default BUILDDIR.
  * msvs2005prj: fixed _WIN32_WCE define for PocketPC 2003 platform (#187).
  * put user- or configure-provided LDFLAGS and LIBS to the end of linker
    command line to avoid conflicts of local libraries with system-wide
    (#182).
  * xcode2: fixed <ldflags> to not delete previously specified flags (#192).
  * xcode2: fixed <cxxflags> and <cppflags> for C++ files (#194).
  * xcode2: fixed <library> handling (#199).
  * added <depends-on-file> to all formats (#190).
  * mingw, gnu: avoid "No rule to make target ..." errors in generated
    makefiles when dependency header is removed (#201).
  * msvs200xprj: don't use /RTC1 flag in release builds with debug information
    enabled (#202).
  * msvs200xprj: enable functions inlining if and only optimization is enabled
    instead of doing it unconditionally (#205).
  * xcode2: added support for <headers> (#208).
  * msvs200xprj: improvements to make generated projects more similar to
    natively created projects (#210).
  * fixes for running on Solaris (#214).
  * xcode2: fixed naming of <dll> targets (#218).
  * check for incorrect used of conditional <set> (#220).
  * added support for multiple source files with the same name (#92).
  * msvs200xprj: fixed to generate correct precompiled headers setting for
    auto vs. manual PCH creation.
  * fixed incorrect dependencies of the "install" target (#225).
  * bakefile_gen --clean removes directories created by Bakefile (#171).
  * fixed <subproject>'s <target> tag to work with all formats (#226).

 -- Vadim Zeitlin <vadim@wxwindows.org>  Oct, 07 Tue 2008 10:49:39 +0200

bakefile (0.2.3) unstable; urgency=low

  * removed support for C++ Builder X, it no longer exists and the format
    wasn't used by anyone in practice
  * significantly improved Xcode format (Kevin Ollivier)
  * fixed running bakefile_gen if the name of temporary directory contains
    spaces
  * msvc6prj: use /pdb linker option to make the projects work when imported
    in MSVC7.1 (Scott Bailey, patch #1732354)
  * msvs2005prj: added support for Pocket PC platform
  * added support for MSVS2003 project files (based on patch by Aleksander
    Jaromin)
  * Bakefile now generates files with output format's platform's default line
    endings; added --eol option to override this (based on patch by Francesco
    Montorsi)
  * added envvar() convenience function for referencing environment variables
  * added --wrap-output command line option for tweaking line-wrapping
    behavior (based on patch by Francesco Montorsi)
  * bakefile_gen uses all available CPUs by default now; use explicit -j1 flag
    to get the old behavior
  * autoconf: fixed shared libraries sonames on NetBSD and OpenBSD
  * added limited support for conditional variables dependent on other
    conditional variables based by Francesco Montorsi (previously, only
    dependency on options was possible)
  * added "debug" level to the <echo> command
  * deprecated <echo level="warning"> in favor of new <warning> command
  * added XML Schema for FORMATS.bkmanifest and Bakefiles.bkgen files
  * autoconf: check if install -d works (patch by Warren Young)
  * dmars: always use -HP99 switch; made the value configurable (#160)
  * autoconf: fixed warning about datarootdir variable with autoconf-2.61+
  * fixed <lib-path> to generated correct output when passed empty string as
    argument (#170; based on patch by Scott Bailey)
  * msvs2005prj: fixed handling of include and library paths with spaces
  * msvc6prj: fixed to not use minimal rebuild with optimization (#42)


=== debian/control ===
Source: bakefile
Section: devel
Priority: optional
Maintainer: Vadim Zeitlin <vadim@wxwindows.org>
Build-Depends: debhelper (>= 4.1.67), autoconf, automake|automake1.7|automake1.8|automake1.9,
 python2.3|python2.4|python2.5, python2.3-dev|python2.4-dev|python2.5-dev,
 docbook-xml, docbook-xsl, libxml2-utils, xsltproc, swig
Standards-Version: 3.6.1

Package: bakefile
Architecture: any
Depends: ${shlibs:Depends}, ${python:Depends}
Recommends: ${python:Depends}-libxml2
Description: cross-platform, cross-compiler native makefiles generator
 Bakefile is a cross-platform, cross-compiler native makefiles generator. It
 takes compiler-independent description of build tasks as input and generates
 native makefile (autoconf's Makefile.in, Visual C++ project, Borland, Watcom
 and other compilers makefiles etc.).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

PYTHON := $(shell python -c "import os.path; print os.path.realpath('/usr/bin/python')")
PYTHON_VER := $(shell $(PYTHON) -V 2>&1 | sed -e 's/Python \([0-9]\.[0-9]\).*/\1/g')

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

configure: configure.in
	./bootstrap

config.status: configure
	dh_testdir
	PYTHON=$(PYTHON) CFLAGS="$(CFLAGS)" ./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --enable-maintainer-mode


build: build-stamp

build-stamp:  config.status
	dh_testdir

	$(MAKE)

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp

	-$(MAKE) distclean
ifneq "$(wildcard /usr/share/misc/config.sub)" ""
	cp -f /usr/share/misc/config.sub config.sub
endif
ifneq "$(wildcard /usr/share/misc/config.guess)" ""
	cp -f /usr/share/misc/config.guess config.guess
endif


	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	$(MAKE) install DESTDIR=$(CURDIR)/debian/bakefile
	mkdir -p $(CURDIR)/debian/bakefile/usr/share/doc/bakefile/html/images
	cp doc/html/*.html doc/html/*.css $(CURDIR)/debian/bakefile/usr/share/doc/bakefile/html
	cp doc/html/images/*.png $(CURDIR)/debian/bakefile/usr/share/doc/bakefile/html/images
	mkdir -p $(CURDIR)/debian/bakefile/etc/bash_completion.d
	cp bash_completion $(CURDIR)/debian/bakefile/etc/bash_completion.d/bakefile


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
	dh_pysupport -V $(PYTHON_VER)
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
